diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFireCold.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFireCold.java
new file mode 100644
index 000000000..1f3bdb28e
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFireCold.java
@@ -0,0 +1,54 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.block.tag.BlockTags;
+import net.minecraft.core.data.gamerule.GameRules;
+import net.minecraft.core.world.World;
+
+import java.util.Random;
+
+public class BlockLogicFireCold extends BlockLogicFire {
+    public BlockLogicFireCold(Block<?> block) {
+        super(block);
+    }
+
+    @Override
+    public void updateTick(World world, int x, int y, int z, Random rand) {
+        Block blockUnder = world.getBlock(x, y - 1, z);
+        boolean infiniBurn = blockUnder != null && blockUnder.hasTag(BlockTags.INFINITE_BURN_COLD) || !world.getGameRuleValue(GameRules.DO_FIRE_SPREAD);
+
+        //Extinguish fire
+        if (!isValidFireLocation(world, x, y, z)) {
+            setBurnResult(world, x, y, z);
+        }
+
+        //Extinguish fire (Rain / Snow)
+        if (!infiniBurn && world.getCurrentWeather() != null && world.getCurrentWeather().isPrecipitation && (
+            world.canBlockBeRainedOn(x, y, z)
+                || world.canBlockBeRainedOn(x - 1, y, z)
+                || world.canBlockBeRainedOn(x + 1, y, z)
+                || world.canBlockBeRainedOn(x, y, z - 1)
+                || world.canBlockBeRainedOn(x, y, z + 1))) {
+            setBurnResult(world, x, y, z);
+            return;
+        }
+
+        int meta = world.getBlockMetadata(x, y, z);
+        if (meta < 15) {
+            world.setBlockMetadata(x, y, z, meta + rand.nextInt(3) / 2);
+        }
+        world.scheduleBlockUpdate(x, y, z, block.id(), tickDelay());
+
+
+        if (!infiniBurn && !canNeighborCatchFire(world, x, y, z)) {
+            if (!world.isBlockNormalCube(x, y - 1, z) || meta > 3) {
+                setBurnResult(world, x, y, z);
+            }
+            return;
+        }
+
+        if (!infiniBurn && !canBurn(world, x, y - 1, z) && meta == 15 && rand.nextInt(4) == 0) {
+            setBurnResult(world, x, y, z);
+            return;
+        }
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluid.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluid.java
index 5d61e5660..c65f10328 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluid.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluid.java
@@ -194,15 +194,19 @@ public abstract class BlockLogicFluid extends BlockLogic
     @Override
     public void animationTick(World world, int x, int y, int z, Random rand)
     {
+        int data = world.getBlockMetadata(x, y, z) & 0x0F;
+        boolean isTop = world.getBlockMaterial(x, y + 1, z) == Material.air && !world.isBlockOpaqueCube(x, y + 1, z);
         if(material == Material.water && rand.nextInt(64) == 0)
         {
-            int data = world.getBlockMetadata(x, y, z) & 0x0F;
             if(data > 0 && data < 8)
             {
                 world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (float) x + 0.5F, (float) y + 0.5F, (float) z + 0.5F, "liquid.water", rand.nextFloat() * 0.25F + 0.75F, rand.nextFloat() * 1.0F + 0.5F);
             }
         }
-        if(material == Material.lava && world.getBlockMaterial(x, y + 1, z) == Material.air && !world.isBlockOpaqueCube(x, y + 1, z) && rand.nextInt(100) == 0)
+        if (material == Material.water && world.dimension == Dimension.NETHER && isTop && data == 0 && rand.nextInt(4) == 0) {
+            world.spawnParticle("smoke", x + Math.random(), y + (14f / 16f), z + Math.random(), 0.0D, 0.0D, 0.0D, 1);
+        }
+        if(material == Material.lava && isTop && rand.nextInt(100) == 0)
         {
             double xOff = (double) x + rand.nextFloat();
             double yOff = (double) y + getBounds().maxY;
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluidFlowing.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluidFlowing.java
index 9643fe9f3..02d06d26d 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluidFlowing.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluidFlowing.java
@@ -65,7 +65,7 @@ public class BlockLogicFluidFlowing extends BlockLogicFluid
                     newFlowDecay = flowDecayAbove + 8;
                 }
             }
-            if(maxCount >= 2 && material == Material.water)
+            if(maxCount >= 2 && (material == Material.water && world.dimension != Dimension.NETHER)) // Become source block
             {
                 if(world.getBlockMaterial(x, y - 1, z).isSolid())
                 {
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicJarButterfly.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicJarButterfly.java
new file mode 100644
index 000000000..bde6e498a
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicJarButterfly.java
@@ -0,0 +1,138 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.TileEntityJarButterfly;
+import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.tag.BlockTags;
+import net.minecraft.core.entity.animal.MobButterfly;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.enums.EnumDropCause;
+import net.minecraft.core.item.Item;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.util.phys.AABB;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
+
+import java.util.function.Supplier;
+
+public class BlockLogicJarButterfly extends BlockLogic {
+    public static final int MASK_HANGING = 0b0000_0001;
+    public static final int MASK_ANGLED = 0b0000_0010;
+    private final Supplier<Item> itemSupplier;
+    private final MobButterfly.ButterflyEntry color;
+
+    public BlockLogicJarButterfly(Block<?> block, MobButterfly.ButterflyEntry color, @NotNull Supplier<Item> itemSupplier) {
+        super(block, Material.glass);
+        this.color = color;
+        this.itemSupplier = itemSupplier;
+        setBlockBounds(0.3125f, 0, 0.3125f, 1 - 0.3125f, 0.5f, 1 - 0.3125f);
+        block.withEntity(() -> new TileEntityJarButterfly(color));
+    }
+
+    @Override
+    public AABB getBlockBoundsFromState(WorldSource world, int x, int y, int z)
+    {
+        int metadata = world.getBlockMetadata(x, y, z);
+        float offset = 0.0F;
+        if ((metadata & MASK_HANGING) != 0)
+            offset = 0.3875F;
+        return AABB.getTemporaryBB(0.3125f, offset,  0.3125f, 1 - 0.3125f, 0.5F + offset, 1 - 0.3125f);
+    }
+
+    @Override
+    public boolean isSolidRender() {
+        return false;
+    }
+
+    @Override
+    public boolean isCubeShaped() {
+        return false;
+    }
+
+    @Override
+    public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xHit, double yHit) {
+        world.setBlockRaw(x, y, z, 0);
+        world.playSoundAtEntity(player, player, "item.pickup", 1f, 1f);
+        if (!world.isClientSide) {
+            world.dropItem(x, y, z, new ItemStack(itemSupplier.get(), 1, 0));
+        }
+        world.markBlockDirty(x, y, z);
+
+        return true;
+    }
+
+    @Override
+    public void onBlockPlacedOnSide(World world, int x, int y, int z, @NotNull Side side, double xPlaced, double yPlaced) {
+        if ((side == Side.BOTTOM || (side != Side.TOP && yPlaced >= 0.5d)) && (world.isBlockNormalCube(x, y + 1, z) || Blocks.hasTag(world.getBlockId(x, y + 1, z), BlockTags.CAN_HANG_OFF))) {
+            world.setBlockMetadataWithNotify(x, y, z, MASK_HANGING);
+            return;
+        }
+        if ((side == Side.TOP || (side != Side.BOTTOM && yPlaced < 0.5d)) && (world.canPlaceOnSurfaceOfBlock(x, y - 1, z))) {
+            world.setBlockMetadataWithNotify(x, y, z, 0);
+            return;
+        }
+        if (world.isBlockNormalCube(x, y + 1, z) || Blocks.hasTag(world.getBlockId(x, y + 1, z), BlockTags.CAN_HANG_OFF)) {
+            world.setBlockMetadataWithNotify(x, y, z, MASK_HANGING);
+        } else world.setBlockMetadataWithNotify(x, y, z, 0);
+    }
+
+    @Override
+    public boolean canPlaceBlockAt(World world, int x, int y, int z) {
+        if (world.isBlockNormalCube(x, y + 1, z) || Blocks.hasTag(world.getBlockId(x, y + 1, z), BlockTags.CAN_HANG_OFF)) {
+            return true;
+        }
+
+        return world.canPlaceOnSurfaceOfBlock(x, y - 1, z);
+    }
+
+    @Override
+    public void onNeighborBlockChange(World world, int x, int y, int z, int blockId) {
+        if (!canBlockStay(world, x, y, z)) {
+            dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, world.getBlockMetadata(x, y, z), null, null);
+            world.setBlockWithNotify(x, y, z, 0);
+        }
+    }
+
+    @Override
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, TileEntity tileEntity) {
+        switch (dropCause) {
+            case PICK_BLOCK:
+            case SILK_TOUCH:
+            case WORLD:
+                return new ItemStack[]{new ItemStack(this.itemSupplier.get())};
+            default:
+                return null;
+        }
+    }
+
+    @Override
+    public boolean canBlockStay(World world, int x, int y, int z) {
+        int meta = world.getBlockMetadata(x, y, z);
+        if ((meta & MASK_HANGING) != 0) {
+            return world.isBlockNormalCube(x, y + 1, z) || Blocks.hasTag(world.getBlockId(x, y + 1, z), BlockTags.CAN_HANG_OFF);
+        }
+
+        return world.canPlaceOnSurfaceOfBlock(x, y - 1, z);
+    }
+
+    @Override
+    public void onBlockDestroyedByPlayer(World world, int x, int y, int z, Side side, int meta, Player player, Item item) {
+        if (item != null && item.isSilkTouch()) {
+            return;
+        }
+        if (!world.isClientSide) {
+            MobButterfly entity = new MobButterfly(world);
+            entity.setColor(color.id);
+            entity.setPos(x + 0.5f + (world.rand.nextFloat() - 0.5f) * 0.5f, y + world.rand.nextFloat() * 0.5f, z + 0.5f + (world.rand.nextFloat() - 0.5f) * 0.5f);
+            world.entityJoinedWorld(entity);
+        }
+    }
+
+    @Override
+    public int getPistonPushReaction(World world, int x, int y, int z) {
+        return Material.PISTON_DESTROY_ON_PUSH;
+    }
+
+}
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLanternFirefly.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLanternFirefly.java
index f6eb75ee8..2ca562e4b 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLanternFirefly.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLanternFirefly.java
@@ -70,6 +70,7 @@ public class BlockLogicLanternFirefly extends BlockLogic {
         {
             world.dropItem(x, y, z, new ItemStack(itemSupplier.get(), 1, 0));
         }
+        world.markBlockDirty(x, y, z);
 
         return true;
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerAsh.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerAsh.java
new file mode 100644
index 000000000..6e05759f2
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerAsh.java
@@ -0,0 +1,77 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.material.Material;
+import net.minecraft.core.enums.EnumDropCause;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.world.World;
+
+public class BlockLogicLayerAsh extends BlockLogicLayerBase
+{
+
+	public BlockLogicLayerAsh(Block<?> block, Block<?> fullBlock, Material material)
+    {
+        super(block, fullBlock, material);
+        setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 0.125F, 1.0F);
+        block.setTicking(true);
+    }
+
+    public void accumulate(World world, int x, int y, int z)
+    {
+    	int myMetadata = world.getBlockMetadata(x, y, z);
+    	if (myMetadata == 0x7) return;
+    	
+    	boolean posXValid = (world.isBlockOpaqueCube(x + 1, y, z)) || (world.getBlockId(x + 1, y, z) == this.id() && world.getBlockMetadata(x + 1, y, z) >= myMetadata);
+    	if (!posXValid) return;
+    	boolean posZValid = (world.isBlockOpaqueCube(x, y, z + 1)) || (world.getBlockId(x, y, z + 1) == this.id() && world.getBlockMetadata(x, y, z + 1) >= myMetadata);
+    	if (!posZValid) return;
+    	boolean negXValid = (world.isBlockOpaqueCube(x - 1, y, z)) || (world.getBlockId(x - 1, y, z) == this.id() && world.getBlockMetadata(x - 1, y, z) >= myMetadata);
+    	if (!negXValid) return;
+    	boolean negZValid = (world.isBlockOpaqueCube(x, y, z - 1)) || (world.getBlockId(x, y, z - 1) == this.id() && world.getBlockMetadata(x, y, z - 1) >= myMetadata);
+    	if (!negZValid) return;
+    	
+    	world.setBlockMetadata(x, y, z, myMetadata + 1);
+    	world.markBlockNeedsUpdate(x, y, z);
+    }
+
+    @Override
+	public boolean canPlaceBlockAt(World world, int x, int y, int z)
+    {
+        int l = world.getBlockId(x, y - 1, z);
+        if(l == 0 || !Blocks.blocksList[l].isSolidRender())
+        {
+        	return false;
+        }
+        else
+        {
+        	Material material = world.getBlockMaterial(x, y - 1, z);
+            return material.blocksMotion();
+        }
+    }
+
+    @Override
+	public void onNeighborBlockChange(World world, int x, int y, int z, int blockId)
+    {
+        // Remove if no longer valid
+        if (!canPlaceBlockAt(world, x, y, z)) {
+            dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, world.getBlockMetadata(x, y, z), null, null);
+            world.setBlockWithNotify(x, y, z, 0);
+        }
+    }
+    @Override
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, TileEntity tileEntity)
+    {
+        switch (dropCause)
+        {
+            case SILK_TOUCH:
+                return new ItemStack[] { new ItemStack(this, meta + 1) };
+            case PICK_BLOCK:
+                return new ItemStack[] { new ItemStack(this) };
+            case EXPLOSION:
+            case PROPER_TOOL:
+//                return new ItemStack[] { new ItemStack(Items.AMMO_SNOWBALL, meta + 1) };
+            default:
+                return null;
+        }
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSnow.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSnow.java
index 2f2b636bb..16ec10324 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSnow.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSnow.java
@@ -19,11 +19,6 @@ public class BlockLogicSnow extends BlockLogic
         block.setTicking(true);
     }
 
-    public int quantityDropped(int meta, Random rand)
-    {
-        return 4;
-    }
-
     @Override
 	public void updateTick(World world, int x, int y, int z, Random rand)
     {
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicStalk.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicStalk.java
new file mode 100644
index 000000000..8f369d1be
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicStalk.java
@@ -0,0 +1,47 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.block.material.Material;
+import net.minecraft.core.util.phys.AABB;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.WorldSource;
+
+public class BlockLogicStalk extends BlockLogic {
+    public BlockLogicStalk(Block<?> block) {
+        super(block, Material.plant);
+        block.setTicking(true);
+        float offset = 0.2F;
+        setBlockBounds(0.5F - offset, 0.0F, 0.5F - offset, 0.5F + offset, offset * 3F, 0.5F + offset);
+    }
+
+    @Override
+    public boolean canPlaceBlockAt(World world, int x, int y, int z) {
+        return super.canPlaceBlockAt(world, x, y, z) && mayPlaceOn(world.getBlockId(x, y - 1, z));
+    }
+
+    protected boolean mayPlaceOn(int blockId)
+    {
+        return Blocks.solid[blockId];
+    }
+
+    @Override
+    public boolean isSolidRender() {
+        return false;
+    }
+
+    @Override
+    public boolean isCubeShaped() {
+        return false;
+    }
+
+    @Override
+    public AABB getCollisionBoundingBoxFromPool(WorldSource world, int x, int y, int z) {
+        return null;
+    }
+
+    @Override
+    public boolean canBlockStay(World world, int x, int y, int z)
+    {
+        return mayPlaceOn(world.getBlockId(x, y - 1, z));
+    }
+
+}
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicStatue.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicStatue.java
new file mode 100644
index 000000000..12f9b7a20
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicStatue.java
@@ -0,0 +1,199 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.TileEntityStatue;
+import net.minecraft.core.block.material.Material;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.enums.EnumDropCause;
+import net.minecraft.core.enums.HumanArmorShape;
+import net.minecraft.core.item.IArmorItem;
+import net.minecraft.core.item.Item;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.util.phys.AABB;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.ArrayList;
+import java.util.List;
+import java.util.function.Supplier;
+
+public class BlockLogicStatue extends BlockLogic {
+    private final boolean isBottom;
+
+    public final @Nullable Supplier<@NotNull Item> droppedItem;
+
+    public BlockLogicStatue(Block<?> block, Material material, boolean isBottom, final @Nullable Supplier<Item> droppedItem) {
+        super(block, material);
+
+        this.isBottom = isBottom;
+        this.droppedItem = droppedItem;
+
+        if (isBottom) {
+            block.withEntity(TileEntityStatue::new);
+        }
+
+        final float bottom = this.isBottom ? 0.0f : -1.0f;
+        final float top = this.isBottom ? 2.0f : 1.0f;
+        setBlockBounds(0.0f, bottom, 0.0f, 1.0f, top, 1.0f);
+    }
+
+    @Override
+    public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xHit, double yHit) {
+        final @NotNull HumanArmorShape armorShape;
+        if (side == Side.TOP || yHit >= 0.5f) {
+            if (this.isBottom) {
+                armorShape = HumanArmorShape.LEGS;
+            } else {
+                armorShape = HumanArmorShape.HEAD;
+            }
+        } else if (side == Side.BOTTOM || yHit < 0.5f) {
+            if (this.isBottom) {
+                armorShape = HumanArmorShape.BOOTS;
+            } else {
+                armorShape = HumanArmorShape.CHEST;
+            }
+        } else {
+            return false;
+        }
+
+        final @Nullable TileEntityStatue statueEntity = getTileEntity(world, x, y, z);
+        if (statueEntity == null) {
+            return false;
+        }
+        final @Nullable ItemStack storedItemStack = statueEntity.getItemInArmorSlot(armorShape);
+
+        boolean takeItem = false;
+        if (storedItemStack != null && storedItemStack.getItem() != null) {
+            takeItem = true;
+        }
+
+        boolean storeItem = false;
+        final @Nullable ItemStack heldItemStack = player.getHeldItem();
+        if (heldItemStack != null) {
+            final @Nullable Item heldItem = heldItemStack.getItem();
+            if (heldItem != null) {
+                if (heldItem instanceof IArmorItem<?> && ((IArmorItem<?>) heldItem).getArmorShape() == armorShape) {
+                    storeItem = true;
+                }
+            }
+        }
+
+        if (takeItem && storeItem) {
+            if (heldItemStack.consumeItem(player)) {
+                final @NotNull ItemStack newStack = heldItemStack.copy();
+                newStack.stackSize = 1;
+                player.inventory.insertItem(storedItemStack, true);
+                statueEntity.setItemInArmorSlot(armorShape, newStack);
+                return true;
+            } else {
+                return false;
+            }
+        } else if (takeItem) {
+            player.inventory.insertItem(storedItemStack, true);
+            statueEntity.setItemInArmorSlot(armorShape, null);
+            return true;
+        } else if (storeItem) {
+            if (heldItemStack.consumeItem(player)) {
+                final @NotNull ItemStack newStack = heldItemStack.copy();
+                newStack.stackSize = 1;
+                statueEntity.setItemInArmorSlot(armorShape, newStack);
+                return true;
+            } else {
+                return false;
+            }
+        } else {
+            if (heldItemStack == null || heldItemStack.getItem() == null) {
+                statueEntity.nextPose();
+                return true;
+            }
+        }
+
+        return false;
+    }
+
+    @Override
+    public boolean isCubeShaped() {
+        return false;
+    }
+
+    @Override
+    public boolean isSolidRender() {
+        return false;
+    }
+
+    public @Nullable TileEntityStatue getTileEntity(final @NotNull World world, final int x, final int y, final int z) {
+        final @Nullable Block<?> block = world.getBlock(x, this.isBottom ? y : y - 1, z);
+        if (block == null || !(block.getLogic() instanceof BlockLogicStatue)) {
+            return null;
+        }
+
+        final @Nullable TileEntity tileEntity = world.getBlockEntity(x, this.isBottom ? y : y - 1, z);
+        if (!(tileEntity instanceof TileEntityStatue)) {
+            return null;
+        }
+
+        return (TileEntityStatue) tileEntity;
+    }
+
+    @Override
+    public void onBlockRemoved(World world, int x, int y, int z, int data) {
+        if (this.isBottom) {
+            List<ItemStack> stacks = new ArrayList<>();
+            final @Nullable TileEntity tileEntity = world.getBlockEntity(x, y, z);
+            if (tileEntity != null) {
+                TileEntityStatue statueEntity = (TileEntityStatue) tileEntity;
+                for (HumanArmorShape armorShape : HumanArmorShape.values()) {
+                    @Nullable ItemStack armorStack = statueEntity.getItemInArmorSlot(armorShape);
+                    if (armorStack != null) {
+                        stacks.add(armorStack);
+                    }
+                }
+            }
+
+            for (ItemStack stack : stacks) {
+                world.dropItem(x, y, z, stack);
+            }
+        }
+    }
+
+    @Override
+    public void onNeighborBlockChange(World world, int x, int y, int z, int blockId) {
+        final Block<?> otherBlock;
+        if (!this.isBottom) {
+            otherBlock = Blocks.blocksList[world.getBlockId(x, y - 1, z)];
+        } else {
+            otherBlock = Blocks.blocksList[world.getBlockId(x, y + 1, z)];
+        }
+        if (!(otherBlock != null && otherBlock.getLogic() instanceof BlockLogicStatue)) {
+            world.setBlockWithNotify(x, y, z, 0);
+        }
+    }
+
+    @Override
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity) {
+        if (droppedItem == null) return null;
+        if (dropCause != EnumDropCause.IMPROPER_TOOL) {
+            return new ItemStack[] { new ItemStack(droppedItem.get()) };
+        }
+
+        return null;
+    }
+
+    @Override
+    public boolean canPlaceBlockAt(World world, int x, int y, int z) {
+        if (y >= world.getHeightBlocks() - 1) {
+            return false;
+        } else {
+            return super.canPlaceBlockAt(world, x, y, z) && super.canPlaceBlockAt(world, x, y + 1, z);
+        }
+    }
+
+    @Override
+    public int getPistonPushReaction(World world, int x, int y, int z) {
+        return Material.PISTON_DESTROY_ON_PUSH;
+    }
+
+}
